property debug_me : true

property script_author : "Jonathan Nathan"
property script_name : "get_rows"
property script_version : "1.0.1"
property script_release_date : "January 31, 2007"
property script_copyright : " 2004, 2007 Jonathan Nathan. All Rights Reserved."

property script_url : "http://www.jonn8.com/"
property script_email : "mailto:Jonathan%20Nathan%20%3Cjonn8%40mac.com%3E?subject=Re:get_rows"

property first_run : true

on will finish launching the_object
	set object_name to name of the_object as Unicode text
	my update_status("will finish launching " & object_name)
	my register_settings()
	my read_settings()
end will finish launching

on launched the_object
	my update_status("launched " & (name of the_object as Unicode text))
	activate
	show window "main"
	if first_run then display window "license" attached to window "main"
end launched

on should quit after last window closed the_object
	return true
end should quit after last window closed

on awake from nib the_object
	set object_name to name of the_object as Unicode text
	my update_status("awake from nib " & object_name)
	if object_name = "main" then
		tell the_object
			if first_run then center
			
			set the_data to {}
			repeat with i from 1 to 10
				set end of the_data to {(some item of {true, false}), "Item " & (i as Unicode text)}
			end repeat
			set the_table to table view 1 of scroll view "with_ds"
			set the_data_source to data source of the_table
			tell the_data_source
				make new data column at end of data columns with properties {name:"col_1"}
				make new data column at end of data columns with properties {name:"col_2"}
				append with the_data
			end tell
			
			set the_table to table view 1 of scroll view "without_ds"
			set the_data_source to make new data source at end of data sources of me
			--the "of me" is important otherwise it caused errors trying to make it at the end of the window, not the app
			set data source of the_table to the_data_source
			tell the_data_source
				make new data column at end of data columns with properties {name:"col_1"}
				make new data column at end of data columns with properties {name:"col_2"}
				append with the_data
			end tell
		end tell
		
	else if object_name = "about" then
		tell the_object
			center
			set contents of text field "title" to (script_name & " v" & script_version)
			set contents of text field "author" to ("by " & script_author)
			set contents of text field "release" to ("Released " & script_release_date)
			set contents of text field "copyright" to (script_copyright)
		end tell
		
	end if
end awake from nib

on activated the_object
	set object_name to name of the_object as Unicode text
	my update_status("activated " & object_name)
end activated

on choose menu item the_object
	set object_name to name of the_object as Unicode text
	my update_status("choose menu item " & object_name)
	
	if object_name = "about" then
		display window "about" attached to window "main"
		
	else if object_name = "quit" then
		quit
		
	end if
end choose menu item

on clicked the_object
	set object_name to name of the_object as Unicode text
	my update_status("clicked " & object_name)
	
	if object_name = "decline" then
		close panel window "license"
		quit
		
	else if object_name = "accept" then
		set first_run to false
		my write_settings()
		close panel window "license"
		
	else if object_name = "dialog_cancel" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "dialog_ok" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "about_webpage" then
		open location script_url
		
	else if object_name = "about_email" then
		open location script_email
		
	else if object_name = "log_data" then
		set the_table to table view 1 of scroll view "with_ds" of window "main"
		set the_data_source to data source of the_table
		tell the_data_source
			set the_contents to contents of data cells of (data rows whose contents of data cell 1 of it = true)
		end tell
		my update_status(the_contents)
		
		set the_table to table view 1 of scroll view "without_ds" of window "main"
		set the_data_source to data source of the_table
		tell the_data_source
			set the_contents to contents of data cells of (data rows whose contents of data cell 1 of it = true)
		end tell
		my update_status(the_contents)
		
	end if
end clicked

on register_settings()
	my update_status("registering settings...")
	tell user defaults
		make new default entry at end of default entries with properties {name:"first_run", contents:first_run}
		register
	end tell
	my update_status("settings registered")
end register_settings

on read_settings()
	my update_status("reading settings...")
	tell user defaults
		set first_run to contents of default entry "first_run"
	end tell
	my update_status("settings read")
end read_settings

on write_settings()
	my update_status("writing settings...")
	tell user defaults
		set contents of default entry "first_run" to first_run
	end tell
	my update_status("settings written")
end write_settings

on update_status(the_message)
	if debug_me then log the_message
end update_status